# -*- coding:utf-8 -*-

DEFAULT_ITEMS = [
  # code, name, name_short, ac_type, cf_type, desc

  {:ac_type => 1, :cf_type => 4, :items => [
  # 1xxx 流動資産
  [1110, '現金',            nil,    1, 4, "財布とは別に置いている現金"],
  [1120, '銀行預金-xx銀行', nil,    1, 4, "普通預金"],
  [1130, '銀行預金-yy銀行', nil,    1, 4, "普通預金"],
  [1140, '郵便貯金',        nil,    1, 4, ""],
  [1210, '小口現金',        '小口', 1, 4, "財布の中の現金"],
  [1220, "商品券・図書券",  nil,    1, 4, "図書券、商品券、テレホンカードなど"],
  ]},

  {:ac_type => 1, :cf_type => 2, :items => [
  # 2xxx 固定資産
  [2610, "有価証券",        nil,    1, 2, "株式，債券など"],
  [2620, '定期預金-xx銀行', nil,    1, 2, "定期預金など"],
  [2630, '定額貯金',        nil,    1, 2, "郵便局の定額貯金"],
  ]},

  {:ac_type => 1, :cf_type => 1, :items => [
  [1410, '未収金',          nil,    1, 1, "未収入のお金"],
  ]},

  {:ac_type => 2, :cf_type => 3, :items => [
  # 4xxx 流動負債
  [4110, '借入金・ローン',        nil,    2, 3, "ローンなど。利子が発生するもの。"],
  ]},

  {:ac_type => 2, :cf_type => 1, :items => [
#  [4140, 'クレジットカード-xx',   nil,    2, 1, "クレジットカード"],
  # 4150 = magic
  [4150, '未払金',                nil,    2, 1, "クレジットカードその他の未払金"],
  [9999, '諸口',                  nil,    2, 1, ""],

  # 5xxx 固定負債
  # 6xxx 法令上の引当金
  ]},

  {:ac_type => 3, :cf_type => 3, :items => [
  # 7xxx 純資産
  # 未処分利益は、特別すぎるので、プログラムで追加する。
  # [7330, "未処分利益", nil, 3, 1, "繰り越している利益の累計"],   # 7330 = magic
  ]},

  {:ac_type => 4, :cf_type => 1, :items => [
  # 8xxx 経常損益
  # 81xx 売上高
  [8120, '給料（手取り）',     nil,    4, 1, "給料の手取り。各種手当てを含み、賞与は含まない。"],  # 010-011
  [8130, "家賃収入",           nil,    4, 1, "不動産を賃貸して得る家賃収入など。"],   # 022
  [8199, "その他の経常収入",   nil,    4, 1, "その他の経常的な収入"],           # 030・033-035
  ]},

  {:ac_type => 5, :cf_type => 1, :items => [
  # 82xx 売上原価

  # 83xx〜85xx 販売費及び一般管理費
  [8310, '食費・食材',      '食費', 5, 1, "食材、定食などの食事代。缶ビールなど。"], # 102-389、3X1-3XX
  [8320, "外食(飲酒)",      "外食", 5, 1, "お酒を伴う外食・飲み代。会食。"],       # 398

  [8330, "家賃、水道光熱費", nil,    5, 1, "家賃・共益費、電気・ガス・水道代など。修繕工事などは含まない。"],

  [8350, "消耗品費",        nil,    5, 1, "日用品、消耗品など"], # 4.5

  [8360, "衣服費",          nil,    5, 1, "洋服、靴，ネクタイなど"],
  [8370, "服サービス費",    nil,    5, 1, "クリーニング，靴修理，仕立て代など"], 

  [8380, "医療費・医薬品",  nil,    5, 1, "薬代・医者代・ビタミン剤，ドリンク剤、コンタクト用品など"],

  [8390, '交通費',          '交通', 5, 1, "電車代、タクシー代など。定期券。旅行に関するものは除く。"], # 7.1
  [8400, "自動車関連費",    "車",   5, 1, "駐車場，ガソリン代・車検・税金など"],

  [8410, "通信費",          nil,    5, 1, "電話代・郵便代・プロバイダ"],

  [8420, "教育費",          nil,    5, 1, "月謝、テキスト代など。文具は含まない。"], # 875

  [8430, '図書・CD費',      nil,    5, 1, "新聞，書籍，CDなど"], # 9.3, 850, 854

  [8440, "レジャー費",      '娯楽', 5, 1, "映画館などの入場料，観覧料など，娯楽関連費"],

  [8450, "保険料",          nil,    5, 1, "生命保険、損害保険など。"],

  [8590, "現金過不足",      nil,    5, 1, ""],
  [8599, 'その他の経常支出', '他',  5, 1, ""],
  ]},

  {:ac_type => 6, :cf_type => 1, :items => [
  # 9xxx 特別損益及び未処分損益
  [9110, "賞与",             nil, 6, 1, "ボーナス、決算手当など臨時的なもの。"],   # 012
  [9210, '受取利息・配当金', nil, 6, 1, "銀行などの利息、受取配当金"],
  [9499, "その他の臨時収支", nil, 6, 1, "その他の臨時的に発生する収入・支出"],
  ]},

  {:ac_type => 7, :cf_type => 1, :items => [
  # [9510, "耐久財購入",  nil,    7, 2, "電化製品，エアコン，たんす，寝具など。"],  # 4.1
  [9520, '旅行費',      '旅行', 7, 1, "旅行に関する支出一式。"], # 9.4.1〜9.4.2
  [9530, "交際費",      "交際", 7, 1, "お中元，お歳暮，冠婚葬祭費，寄付金など"],
  [9610, '支払利息',    nil,    7, 1, ""],
  ]},
]
