
require APP_ROOT + '/models/partner'
require APP_ROOT + '/models/journal_entry'
require APP_ROOT + '/models/payment_amount'

class Invoice < ActiveRecord::Base
  belongs_to :user
  belongs_to :partner
  has_many :payment_amounts

  # 仕訳. 所有関係ではないので:dependentは付けない。
  has_many :journal_entries

  attr_protected :user_id

  before_save :update_amount_total

  # @override
  def validate
    if journal_entries.empty?
      errors.add_to_base "一件も明細がありません。"
    end
  end

  def update_amount_total
    self.amount_total = journal_entries.inject(0) {|result, r| 
      result += r.amount
    }
  end
  private :update_amount_total

  def get_paid
    if !@paid_
      @paid_ = 0
      if payment_amounts
        payment_amounts.each {|pay| @paid_ += pay.amount}
      end
    end
    return @paid_
  end
end
