# -*- coding:utf-8 -*-

require 'digest/md5'

# ユーザ
class User < ActiveRecord::Base
  validates_uniqueness_of :login
  has_one :user_setting, :dependent => :destroy

  has_many :account_titles, :dependent => :destroy
  has_many :journal_entries, :dependent => :destroy
  has_many :budgets, :dependent => :destroy
  has_many :partners, :dependent => :destroy

  def set_password(new_pwd)
    self.crypted_password = Digest::MD5.new.update(new_pwd).hexdigest
  end

=begin
  dynamic attribute-based finderで取得できる
  def self.find_by_login(login_name)
    return find(:first, :conditions => ['login = ?', login_name])
  end
=end

  def self.check_passwd(login_, pwd_)
    raise TypeError if !login_.is_a?(String)
    raise TypeError if !pwd_.is_a?(String)

    # expire sweep
    find(:all, :conditions => ["expire < ?", Time.now]).each {|ent|
      delete(ent.id)
    }

    ent = find_by_login(login_)
    if !ent || ent.crypted_password != Digest::MD5.new.update(pwd_).hexdigest
      return false
    else
      ent.expire = nil
      ent.save!
      return true
    end
  end

  # 退会処理
  # @param users ユーザログインIDの配列
  def self.delete_user_data(users)
    require APP_ROOT + '/models/budget_detail' 

    users.each {|name|
      ent = User.find_by_login(name)
      next if !ent
      cond = ['user_id = ?', ent.id]

      User.transaction {        
        UserSetting.delete_all(cond)
        JournalEntry.delete_all(cond)
        BudgetDetail.find_by_sql [
"DELETE FROM budget_details WHERE budget_id in (SELECT id FROM budgets WHERE user_id = ?)", ent.id]
        Budget.delete_all(cond)
        AccountTitle.delete_all(cond)
        EmailLog.delete_all(cond)
        PaymentAmount.find_by_sql [
"DELETE FROM payment_amounts WHERE payment_id in (SELECT id FROM payments WHERE user_id = ?)", ent.id]
        Payment.delete_all(cond)
        Invoice.delete_all(cond)
        Partner.delete_all(cond)
        User.delete ent.id
      } # of transaction
    } 
  end
end
