
# ユーザ設定
class UserSetting < ActiveRecord::Base
  belongs_to :user
  set_primary_key :user_id

  # 仕訳追加可能期間
  def get_addable_period()
    return [fixed_date + 1, (fixed_date + 1) + 50]
  end

  # 締め日の翌日から次の月末日まで
  def self.get_ac_month(user)
    r = find :first, :conditions => ['user_id = ?', user.id] 
    raise if !r

    begin_date = r.fixed_date + 1
    if begin_date.day <= r.closing_day
      y = begin_date.year
      m = begin_date.mon
    else
      y = next_month(begin_date).year
      m = next_month(begin_date).mon
    end
    d = r.closing_day
    while !Date.exist?(y, m, d)
      d -= 1
    end
    return [begin_date, Date.new(y, m, d)]
  end
end
