# -*- coding: utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2009 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/

# 共通のアプリケーションクラス

class File
  def File.rel2abs(rel_path, this_file)
    File.expand_path(rel_path, File.dirname(File.expand_path(this_file)))
  end
end


require File.dirname(__FILE__) + "/banner-conf.rb" 
require CONF_DIR + "/ac-conf.rb"

require 'rubygems'
require "date"
gem 'activesupport'
gem 'activerecord'
require 'active_support'
require 'active_record'
require LIBRARY_DIR + "/common.rb"
require LIBRARY_DIR + "/injector.rb"
require 'wafu/webapp.rb'
require APP_ROOT + '/models/user'
require APP_ROOT + '/models/user_setting'

require 'amrita/template' # for backward compatibility

# require File.rel2abs("multiparam_errors", __FILE__)


ENV['PATH'] = '/bin'

# アプリケーションクラス
class AccountingApp < Wafu::WebApp
  def initialize(opt_hash = {})
    ActiveRecord::Base.establish_connection AR_OPTION

    opt = {
      "session_type" => "auth_required",
      "session_option" => {
        "tmpdir" => SESSION_DIR, 
        "holdtime" => SESSION_HOLD_TIME},
      "passwd_store" => User
    }
    opt.update(opt_hash)
    super(opt)
  end

  def setup
    @user = User.find_by_login(@user) if @user
  end
end


# 部分テキストを生成する
def mod_render(file, model)
  raise SecurityError if file =~ /\//
  tmpl = Amrita::TemplateText.new(File.read("#{APP_ROOT}/templates/" + file).untaint)
  tmpl.amrita_id = "tid"
  utext = ""
  tmpl.expand(utext, model)
  return utext
end


def run(app) # for backward compatibility 
  app.run()
end

=begin
def current_month()
  year, mon = []
  File.open(CURRENT_MONTH) {|fp|
    fp.flock(File::LOCK_SH)
    year, mon = fp.gets.gsub(/[\r\n]/, '').split("/")
  }
  s = <<EOF
<input type="hidden" name="current-year" value="#{year}">
<input type="hidden" name="current-month" value="#{mon}">
<p>#{year}年#{mon}月度
EOF
  return s
end
=end


# 翌月（歴月）の初日を表すDateインスタンス
def next_month(date)
  r = date + 1
  while r.mon == date.mon
    r += 1
  end
  return r
end


def format_date(d)
  sprintf("%04d.%02d.%02d", d.year, d.mon, d.day)
end

def format_date_long(d)
  sprintf("%04d年%2d月%2d日", d.year, d.mon, d.day)
end
