#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Web Account Book
# Copyright (c) 2002-2007,2010 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/


# 予算 (列) の編集

require "pcview.rb"
require APP_ROOT + '/models/budget_detail'
require APP_ROOT + '/models/account_title'


class BudgetsEdit < Wafu::Action
  def execute af
    @budget = Budget.find :first, 
            :conditions => ["user_id = ? AND id = ?", app.user.id, af["id"]]
    raise ArgumentError if !@budget

    @bday = Date.parse af["b"]
    @eday = Date.parse af["e"]

    # 勘定科目をグループに分ける
    @grp = []
    ac_titles = AccountTitle.find :all, 
                              :conditions => ["user_id = ?", app.user.id]
    ac_titles.each do |item|
      next if item.cf_type == 4
      @grp[item.ac_type] ||= []

      bd = (@budget.budget_details.detect do |x| 
                                        x.account_title_id == item.id end)
      @grp[item.ac_type] << [item, bd ? bd.amount * item.sign: nil]
    end

    render "budgets-edit", :layout => "application"
  end

end


class BudgetsUpdate < Wafu::Action
  def execute af
    @budget = Budget.find :first, 
            :conditions => ["user_id = ? AND id = ?", app.user.id, af["id"]]
    raise ArgumentError if !@budget

    @bday = Date.parse af["bday"]
    @eday = Date.parse af["eday"]

    @budget.date = Date.new af["dyear"].to_i, af["dmon"].to_i, af["dday"].to_i
    # TODO: コメント

    Budget.transaction do 
      BudgetDetail.delete_all ["budget_id = ?", @budget.id]

      lines = af["lines"].to_i
      (0 .. lines -1).each do |i|
        title = AccountTitle.find :first, 
         :conditions => ["user_id = ? AND id = ?", app.user.id, af["ac#{i}"]]
        raise if !title

        amount = af["am#{i}"].to_i
        if amount != 0
          bd = BudgetDetail.new :account_title => title, 
                              :amount => amount * title.sign
          @budget.budget_details << bd
        end
      end

      @budget.save!
      # TODO: エラーチェック
    end # transaction

    @bday = [@bday, @budget.date].min
    @eday = [@eday, @budget.date].max

    app.set_flash "notice", "予算 (列) #{@budget.date} を更新しました。"
    app.redirect_to "budgets-list.rb", :action => "view", 
                            :b => @bday, :e => @eday
  end
end


(PCView.new :actions => {
  "*" => [Wafu::ActionForm, BudgetsEdit, nil],
  "update" => [Wafu::ActionForm, BudgetsUpdate, nil]
 } ).run
