#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Web Account Book
# Copyright (c) 2002-2007,2010 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/


# 新しい予算 (列)

require "pcview.rb"
require APP_ROOT + '/models/budget_detail'
require APP_ROOT + '/models/account_title'


class BudgetsNew < Wafu::Action
  def execute af
    @budget = Budget.new :date => Date.today

    if af["b"] && af["b"] != ""
      @bday = Date.parse af["b"]
      @eday = Date.parse af["e"]
    else
      @bday = app.user.user_setting.get_addable_period[0]
      @eday = (@bday >> 12) - 1
    end

    # 勘定科目をグループに分ける
    @grp = []
    ac_titles = AccountTitle.find :all, 
                              :conditions => ["user_id = ?", app.user.id]
    ac_titles.each_with_index do |item, i|
      next if item.cf_type == 4
      @grp[item.ac_type] ||= []
      @grp[item.ac_type] << [item, nil]
    end

    render "budgets-new", :layout => "application"
  end

end


class BudgetsCopyNew < Wafu::Action
  def execute af
    orig_budget = Budget.find :first, 
            :conditions => ["user_id = ? AND id = ?", app.user.id, af["id"]]
    raise ArgumentError if !orig_budget

    @budget = Budget.new :date => orig_budget.date
    @bday = Date.parse af["b"]
    @eday = Date.parse af["e"]

    # 勘定科目をグループに分ける
    @grp = []
    ac_titles = AccountTitle.find :all, 
                              :conditions => ["user_id = ?", app.user.id]
    ac_titles.each do |item|
      next if item.cf_type == 4
      @grp[item.ac_type] ||= []

      bd = (orig_budget.budget_details.detect do |x| 
                                        x.account_title_id == item.id end)
      @grp[item.ac_type] << [item, bd ? bd.amount * item.sign: nil]
    end

    render "budgets-new", :layout => "application"
  end
end


class BudgetsCreate < Wafu::Action
  def execute af
    date = Date.new af["dyear"].to_i, af["dmon"].to_i, af["dday"].to_i
    @bday = Date.parse af["bday"]
    @eday = Date.parse af["eday"]

    budget = Budget.new :user => app.user, :date => date, :comment => ""
    # TODO: コメント

    lines = af["lines"].to_i
    (0 .. lines -1).each do |i|
      title = AccountTitle.find :first, 
         :conditions => ["user_id = ? AND id = ?", app.user.id, af["ac#{i}"]]
      raise if !title

      amount = af["am#{i}"].to_i
      if amount != 0
        bd = BudgetDetail.new :account_title => title, 
                              :amount => amount * title.sign
        budget.budget_details << bd
      end
    end

    budget.save!
    # TODO: エラーチェック

    @bday = [@bday, budget.date].min
    @eday = [@eday, budget.date].max

    app.set_flash "notice", "予算を作成しました。"
    app.redirect_to "budgets-list.rb", :action => "view", 
                            :b => @bday, :e => @eday
  end
end


(PCView.new :actions => {
  "*" => [Wafu::ActionForm, BudgetsNew, nil],
  "copy_new" => [Wafu::ActionForm, BudgetsCopyNew, nil],
  "create" => [Wafu::ActionForm, BudgetsCreate, nil]
 } ).run
