#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/

# PC用　現金の残高をあわせる。差額は雑費などへ。


require "pcview.rb"
require "journal-common.rb"


class SetupAF < Wafu::ActionForm
  def setup
    day = Time.now
    day = Date.new(day.year, day.mon, day.day) - 1 if day.hour < 3
    @mon = day.mon
    @day = day.day
    @accode = app.user.user_setting.cash_balance_last_item
  end
  attr_reader :mon, :day, :mcode, :amount, :accode, :remarks
end


class CashBalance < Wafu::Action
  def execute af
    # 選択肢は損益科目のみ
    titles = AccountTitle.find :all,
                      :conditions => ['user_id = ? AND active <> 0 AND (ac_type = 4 OR ac_type = 5)', app.user.id],
                      :order => 'ac_type, sort'
     
    model = {
      :mon => af.mon,
      :day => af.day,
      :mcode => get_sel_active_items(app.user, "mcode", af.mcode) {|item| item.cf_type == 4},
      :accode => get_sel_acitems_sub(titles, "accode", af.accode),
      :errors => af.errors,
      :amount => af.amount,
      :remarks => af.remarks
    }
    app.page_out("cash-balance.html", model)
  end
end


class BalanceAF < Wafu::ActionForm
  def setup
    set_cgi_attrs 'mon' => 'int', 'day' => 'int', 'mcode' => 'int', 
                  'accode' => 'int', 'amount' => 'int', 'remarks' => String  
  end

  def validate
    err = []
    period = app.user.user_setting.get_addable_period
    date = get_full_day mon, day, (period[0] << 3)
    if !date
      err << "日付が正しくありません。"
    elsif date < period[0]
      err << "#{date} は締め処理日より古い日付です。登録できません。"
    elsif date > period[1]
      err << "#{date} は登録可能期間の外です。締め処理をおこなって、登録可能期間を進めてください。"
    end
    return set_error(err)
  end
end


class DoneAction < Wafu::Action
  def execute af
    prof = app.user.user_setting
    period = prof.get_addable_period

    # 当日の残高を得る
    day = get_full_day(af.mon, af.day, period[0])
    raise if day < period[0] || day > period[1]
    b = JournalEntry.carrying_amount app.user, 
                                     AccountTitle.find(af.mcode), 
                                     day + 1
    if af.amount != b
      r = JournalEntry.new :user => app.user,
              :date => get_full_day(af.mon, af.day, period[0]),
              :entry_no => (prof.entry_no_counter += 1),
              :dr_code => af.amount > b ? af.mcode : af.accode,
              :cr_code => af.amount > b ? af.accode : af.mcode,
              :amount => af.amount > b ? af.amount - b : b - af.amount,
              :remarks => '',
              :comment => af.remarks
      r.save!

      model = {
        :if_add => {
          :date => r.date,
          :dr => AccountTitle.find(r.dr_code).name,
          :cr => AccountTitle.find(r.cr_code).name,
          :amount => r.amount,
          :remarks => af.remarks
        }
      }
    else
      model = {
        :no_add => true
      }
    end
    prof.cash_balance_last_item = af.accode
    prof.save!

    app.page_out "cash-balance-done.html", model
  end
end


if __FILE__ == $0
PCView.new('actions' => {
  '*' => [SetupAF, CashBalance, nil],
  'done' => [BalanceAF, DoneAction, CashBalance]
}).run
end

