#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002,2009 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/

require "pcview.rb"


# 締め処理（画面）
class UserSettingCloseBook < Wafu::Action
  def execute af
    @fixed_day = app.user.user_setting.fixed_date
    b_, @end_date = UserSetting.get_ac_month(app.user) 
    render "setting-close-book"
  end
end

class UserSettingCloseBookDo < Wafu::Action
  def execute af
    @errors = []
    user_setting = app.user.user_setting
    @fixed_day = user_setting.fixed_date

    y = af["year"].to_i
    m = af["mon"].to_i
    d = af["day"].to_i
    if !Date.exist?(y, m, d)
      @errors << "日付が不正です。"
      b_, @end_date = UserSetting.get_ac_month(app.user)
      render 'setting-close-book'
      return
    end

    @end_date = Date.new(y, m, d)

    if @end_date < @fixed_day 
      @errors << "締め日を遡らせることはできません。"
      render 'setting-close-book'
    else
      user_setting.fixed_date = @end_date
      user_setting.save!
      app.set_flash 'notice', "締め日を#{@end_date}に設定しました。"
      app.redirect_to 'menu.rb'
    end
  end
end

PCView.new("actions" => {
             '*' => [nil, UserSettingCloseBook, nil],
             'do' => [Wafu::ActionForm, UserSettingCloseBookDo, nil]
           }).run
