#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Web Account Book
# Copyright (c) 2002-2007,2010 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/

require 'pcview.rb'
require APP_ROOT + '/models/account_title'
require APP_ROOT + '/models/journal_entry'
require APP_ROOT + '/models/budget'
require APP_ROOT + '/models/partner'
require APP_ROOT + '/models/email_log'
require APP_ROOT + '/models/invoice'
require APP_ROOT + '/models/payment'
require APP_ROOT + '/models/budget_detail'
require APP_ROOT + '/models/payment_amount'

class Confirm < Wafu::Action
  def execute af
    model = { }

    if app.user.login == "guest"
      @errors = ["ゲストユーザは退会処理できません。"]
      @page_title = "サービスの終了 (退会)"
      render "account-forbid-guest", :layout => "application"
      return
    end

    if af && af.error?
      model[:errors] ||= { :message => [] }
      model[:errors][:message] << af.errors
    end
    app.page_out('end_service.html', model)
  end
end

class AgreeAF < Wafu::ActionForm
  attr_reader :checked
  def validate
    @checked = app.cgi.get('un', '') != ''

    err = []
    if !@checked 
      err << 'チェックが入っていません。'
    end
    return set_error(err)
  end
end

class Done < Wafu::Action
  def execute(af)
    User.delete_user_data(app.user.login)
    model = { 
      :body_header => Amrita::SanitizedString[app.body_header]
    }
    app.page_out('end_service_done.html', model)
    app.session.delete
  end
end

if __FILE__ == $0
  PCView.new('actions' => {
    '*' => [nil, Confirm, nil],
    'agree' => [AgreeAF, Done, Confirm]
  }).run
end
