#!/home/netsphere/bin/ruby
# -*- coding:utf-8; mode:ruby -*-


# Webページにコメントを付けてもらう

class File
  def File.rel2abs(rel_path, this_file)
    File.expand_path(rel_path, File.dirname(File.expand_path(this_file)))
  end
end
require File.rel2abs("./banner-conf.rb", __FILE__)
require File.rel2abs("./banner.rb", __FILE__)
require LIBRARY_DIR + "/cgisup.rb"
require LIBRARY_DIR + "/injector.rb"
require CONF_DIR + "/ac-conf.rb"

$SAFE = 1
ENV['PATH'] = '/bin'
=begin
PATHにworld writableなディレクトリが含まれているとFile.popen()などで
'Insecure PATH'例外が発生
=end

def header_out(title)
  print <<EOF
Content-Type:text/html; charset=UTF-8

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML LANG="ja">
<head>
  <LINK rel="start" href="http://www.nslabs.jp/">
  <LINK rel="copyright" href="copyright.rhtml">
  <LINK rel="stylesheet" href="./default.css" type="text/css">
  <META name="ROBOTS" content="NOINDEX, NOFOLLOW">
  <TITLE>#{title}</title>
</head>
<body>
EOF
end

def value(cgi, name, default = "(nil)")
  if !cgi[name].empty?
    r = cgi[name].first.strip
  end
  if !r || r == ""
    return default
  else
    return r
  end
end

# メールを作成する
def make_mail(cgi, key, body)
  raise "setting miss!!" if !AppConfig[:prog_mail] || !AppConfig[:admin_mail]

  name = value(cgi, 'name')
  from = value(cgi, 'from', nil)
  content = value(cgi, 'uu')

  # SPAMの可能性が高いものを弾く
  if body !~ /[^A-Za-z0-9 .,\r\n!-]/
    return nil
  elsif body.index(/<a[ \t\n]+href=/i) || body.index('http:')
    return nil
  elsif content == "(nil)" && body.strip == ""
    return nil
  end

  subject = "シンプルWeb家計簿 feedback"
  head = {"From" => AppConfig[:prog_mail],
          "To" => AppConfig[:admin_mail],
          "Subject" => subject,
          "MIME-Version" => "1.0",
          "Content-Type" => "text/plain; charset=ISO-2022-JP"}
  if from && from != "" && from !~ /[^\x21-\x7e]/
    head["Reply-To"] = from
  end

  mailbody = <<EOF
Webサイトのページに対するコメントがありました。

page: #{key}
time: #{CGI.rfc1123_date(Time.now)}

name: #{name}
mail: #{from ? from : "(nil)"}
remote_host: #{ENV['REMOTE_HOST'] || get_hostname(ENV['REMOTE_ADDR'].dup.untaint)}
ua: #{ENV['HTTP_USER_AGENT']}
http_referer: #{ENV['HTTP_REFERER']}
referer2: #{value(cgi, 'r')}

ページの評価
content: #{content}

<comment>
EOF
  body.split(/\r?\n/).each {|line|
    mailbody << "#{line}\n"
  }
  mailbody << "</comment>\n"

  return [head, mailbody]
end

def main()
  cgi = CGI.new

  if !cgi['body'].empty? then
    body = cgi['body'].first.strip
  else
    body = ""
  end
  key = cgi['k'].first
  
  header_out("feedback")
  navbar = NavBar.new
  navbar.top()

  mail = make_mail(cgi, key, body)
  if mail
    send_mail(mail[0], mail[1])

    # 結果を表示

    print <<EOF
<h1>コメント送信</h1>

<p>ページ #{key} について，次のコメントを送信しました。有り難うございました。

<table style="margin-top:1em">
  <tr><th>お名前:<td>#{CGI.escapeHTML(value(cgi, 'name'))}
  <tr><th>メール:<td>#{CGI.escapeHTML(value(cgi, 'from'))}
</table>
<pre>
EOF
  body.each {|line|
    print CGI.escapeHTML(line), "\n"
=begin
j2e()を内側に書く。html_escape()にiso-2022-jpを渡すと文字化けする
=end
  }
  print <<EOF
</pre>
<p><a href="./">シンプルWeb家計簿 Home</a>
<hr>
EOF
  else
    print <<EOF
<h1>コメントを送信しませんでした。</h1>
<p>HTMLタグまたはhttp:が含まれているため、コメントを送信しませんでした。
EOF
  end
  navbar.bottom(nil, "euc", false)
end

begin
  main()
rescue StandardError, ScriptError
  print "Content-Type: text/html\n\n"
  print "<p>#{CGI.escapeHTML($!.inspect)}<br>\n"
  $@.each {|x| print CGI.escapeHTML(x), "<br>\n"}
  banner_footer_out('')
end
