#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# AP: 請求書の削除

require "pcview.rb"
require APP_ROOT + '/models/invoice'
require APP_ROOT + '/models/account_title'
require APP_ROOT + '/models/journal_entry'
require LIBRARY_DIR + '/datesup.rb'


class InvoicesDestroy < Wafu::Action
  def execute af
    @invoice = Invoice.find :first, 
                   :conditions => ['id = ? AND user_id = ?', 
                                   af['id'], app.user.id]
    raise if !@invoice

    period = app.user.user_setting.get_addable_period
    journal_day = @invoice.journal_entries.first.date

    # このアクションには来ないはず
    raise if journal_day < period[0] || journal_day > period[1]

    Invoice.transaction {
      JournalEntry.delete_all ["invoice_id = ?", @invoice.id]
      @invoice.destroy
    }

    app.set_flash "notice", "請求書: #{@invoice.date}, #{decimal_format(@invoice.amount_total)}円 を削除しました。"
    app.redirect_to 'invoices-list.rb'
  end
end


PCView.new('actions' => {
             '*' => [Wafu::ActionForm, InvoicesDestroy, nil],
           }).run
