#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 請求書 (AP) の編集・更新

require "pcview.rb"
require APP_ROOT + '/models/invoice'
require APP_ROOT + '/models/account_title'
require APP_ROOT + '/models/journal_entry'
require LIBRARY_DIR + '/datesup.rb'


# 編集 (画面)
class InvoicesEdit < Wafu::Action
  def execute af
    @period = app.user.user_setting.get_addable_period

    @invoice = Invoice.find :first, 
                   :conditions => ['id = ? AND user_id = ?', 
                                   af['id'], app.user.id]
    @journals = @invoice.journal_entries

    render 'invoices-edit'
  end
end


# 更新
class InvoicesUpdate < Wafu::Action
  def execute af
    @invoice = Invoice.find :first, 
                       :conditions => ['id = ? AND user_id = ?',
                                       af['id'], app.user.id]
    raise if !@invoice
    @invoice.attributes = af['invoice']

    @journals = []
    lines = af['lines'].to_i
    (1..lines).each {|i|
      @journals << JournalEntry.new(af['journals'][i.to_s])
    }

    user_setting = app.user.user_setting
    @period = user_setting.get_addable_period
=begin
    if !@invoice.multiparam_errors.empty?
      @invoice.add_errors_from_multiparam_errors
      render "invoices-edit"
      return
    end
=end

    if @invoice.date < @period[0] || @invoice.date > @period[1]
      if @invoice.date < @period[0]
        @invoice.errors.add 'date', "登録可能期間外です。"
      else
        @invoice.errors.add 'date', "登録可能期間より未来の日付です。メニューから締め処理をおこなってください。"
      end
      render 'invoices-edit'
      return
    end

    begin
      Invoice.transaction {
        # 仕訳を更新。
        # 登録可能期間内なので、単に仕訳を一度消す
        JournalEntry.delete_all ["invoice_id = ?", @invoice.id]
        @invoice.journal_entries.clear

        entry_no = (user_setting.entry_no_counter += 1)
        user_setting.save!

        @journals.each {|line|
          if line.amount && line.amount != 0
            line.attributes = {
              :user => app.user,
              :date => @invoice.date,
              :entry_no => entry_no,
              :cr_code => user_setting.payable_item,
              :remarks => @invoice.partner.name
            }
            @invoice.journal_entries << line
          end
        }
        @invoice.save!
      }
    rescue ActiveRecord::RecordInvalid
      render 'invoices-edit'
      return
    end

    app.set_flash "notice", "請求書を更新しました。"
    app.redirect_to "invoices-show.rb?id=#{@invoice.id}"
  end
end


PCView.new('actions' => {
             '*' => [Wafu::ActionForm, InvoicesEdit, nil],
             'update' => [Wafu::ActionForm, InvoicesUpdate, nil]
           }).run
