#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Web Account Book
# Copyright (c) 2002-2007,2010 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/

# 請求書 (AP) の一覧

require "pcview.rb"
require APP_ROOT + '/models/invoice'
require APP_ROOT + '/models/account_title'
require APP_ROOT + '/models/journal_entry'
require LIBRARY_DIR + '/datesup.rb'


# 請求書の一覧
# payment-common.rb にも似たのがあるが、あっちは更新用画面
class InvoicesIndex < Wafu::Action
  def execute af
    @unpaid_invoices = 
        Invoice.find :all,
            :select => "invoices.*, amo.paid",
            :joins => "LEFT JOIN (SELECT invoice_id, SUM(amount) AS paid FROM payment_amounts GROUP BY invoice_id) amo ON invoices.id = amo.invoice_id",
            :conditions => ["invoices.user_id = ? AND ((amo.paid IS NULL) OR invoices.amount_total <> amo.paid)", app.user.id]

    @page = af["page"].to_i

    @invoices = Invoice.find :all, 
                     :conditions => ['user_id = ?', app.user.id],
                     :offset => @page * 25,
                     :limit => 25,
                     :order => 'date DESC, id' 

    render 'invoices-list'
  end
end


PCView.new('actions' => {
      '*' => [Wafu::ActionForm, InvoicesIndex, nil],
}).run

