#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 請求書 (AP) の登録

require "pcview.rb"
require APP_ROOT + '/models/invoice'
require APP_ROOT + '/models/account_title'
require APP_ROOT + '/models/journal_entry'
require LIBRARY_DIR + '/datesup.rb'


# 新しい請求書（画面）
class InvoicesNew < Wafu::Action
  def execute(af)
    # マスタはある？
    err = []
    if !app.user.user_setting.payable_item
      err << "未払金勘定の設定がありません。勘定科目マスタ画面で設定してください。" 
    end
    partner = Partner.find :first, :conditions => ['user_id = ?', app.user.id]
    if !partner
      err << "取引先が一件もありません。[取引先]画面で登録してください。" 
    end

    if !err.empty?
      model = {:errors => err}
      app.page_out("purchase_new_error.html", model)
      return
    end

    # 編集画面
    @period = app.user.user_setting.get_addable_period

    @invoice = Invoice.new(:partner => partner, 
                           :date => Date.today)
    @journals = []

    render "invoices-new"
  end
end


# 請求書を作成
class InvoicesCreate < Wafu::Action
  def execute(af)
    @invoice = Invoice.new(:user => app.user)
    @invoice.attributes = af['invoice']

    @journals = []
    lines = af['lines'].to_i
    (1..lines).each {|i|
      @journals << JournalEntry.new(af['journals'][i.to_s])
    }

    user_setting = app.user.user_setting
    @period = user_setting.get_addable_period
=begin
    if !@invoice.multiparam_errors.empty?
      @invoice.add_errors_from_multiparam_errors
      render "invoices-new"
      return
    end
=end

    if @invoice.date < @period[0] || @invoice.date > @period[1]
      if @invoice.date < @period[0]
        @invoice.errors.add 'date', "登録可能期間外です。"
      else
        @invoice.errors.add 'date', "登録可能期間より未来の日付です。メニューから締め処理をおこなってください。"
      end
      render 'invoices-new'
      return
    end

    entry_date = @invoice.date

    begin
      Invoice.transaction {
        entry_no = (user_setting.entry_no_counter += 1)
        user_setting.save!

        @journals.each {|line|
          if line.amount && line.amount != 0
            line.attributes = {
              :user => app.user, 
              :date => entry_date,
              :entry_no => entry_no,
              :cr_code => user_setting.payable_item,
              :remarks => @invoice.partner.name
            }
            @invoice.journal_entries << line
          end
        }
        @invoice.save!
      } 
    rescue ActiveRecord::RecordInvalid
      render 'invoices-new'
      return
    end
    app.set_flash("notice", "請求書: #{@invoice.date}, #{decimal_format(@invoice.amount_total)}円 を登録しました。")
    app.redirect_to "invoices-new.rb"
  end
end


PCView.new('actions' => {
      '*' => [nil, InvoicesNew, nil],
      'create' => [Wafu::ActionForm, InvoicesCreate, nil]
}).run
