#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 仕訳帳

require 'ostruct'
require "pcview.rb"
require APP_ROOT + '/models/invoice.rb'
require APP_ROOT + '/models/payment_amount.rb'


# 仕訳帳の表示
class JournalsList2 < Wafu::Action
  def execute(af)
    @fixed_day = app.user.user_setting.fixed_date
    op_date = app.user.user_setting.opening_date

    @term = OpenStruct.new({
      :from => af['from'] ? Date.parse(af['from']) : date_from_select(af['term'], 'from'),
      :to => af['to'] ? Date.parse(af['to']) : date_from_select(af['term'], 'to')
    })
    @term.from = op_date + 1 if @term.from <= op_date
    @term.to = op_date + 1 if @term.to <= op_date

    @journals = JournalEntry.find(:all, 
                     :conditions => ['user_id = ? AND date BETWEEN ? and ?',
                                     app.user.id, @term.from, @term.to],
                     :order => 'date, entry_no, id')

    # 新しい期間選択
    from, to = UserSetting.get_ac_month(app.user)
    @new_term = OpenStruct.new({
      :from => from,
      :to => [to, Date.today].max
    })

    render "journals-list2"
  end
end


PCView.new('actions' => {
  "*" => [Wafu::ActionForm, JournalsList2, nil]
}).run
