#!/home/netsphere/bin/ruby

# Q's Account Book
# Copyright (c) 2002-2008 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 携帯用　元帳

require '../mobile_app.rb'
require APP_ROOT + '/models/account_title'
require APP_ROOT + '/models/journal_entry'


class SetupAF < Wafu::ActionForm
  def setup
    @year = app.cgi.get('y')
    @mon = app.cgi.get('m')
    @day = app.cgi.get('d')
    @accode = app.cgi.get('code')
  end
  attr_reader :year, :mon, :day, :accode

  def validate
    # TODO:
  end
end


class LedgerList < MobileAction
  def execute af
    day = Date.new af.year.to_i, af.mon.to_i, af.day.to_i
    model = {
      :day => day,
      :data => [],
    }
    item = AccountTitle.find af.accode
    # 繰越額
    balance = item.bs? ? JournalEntry.carrying_amount(app.user, item, day) : 0
    entries = JournalEntry.find :all,
                  :conditions => ['user_id = ? AND (dr_code = ? OR cr_code = ?) AND date = ?',
                                  app.user.id, item.id, item.id, day],
                  :order => 'date, entry_no, id'

    if item.bs?
      model[:data] << {
        :partner => '',
        :remarks => "繰越",
        :amount => decimal_format(balance * item.sign)
      }
    end
    entries.each {|r|
      model[:data] << {
        :partner => r.remarks,
        :remarks => r.comment,
        :amount => decimal_format(r.amount)
      }
      balance += r.dr_code == item.id ? r.amount : -r.amount
    }
    model[:data] << {
      :partner => '',
      :remarks => (item.bs? ? '残高' : '合計'),
      :amount => decimal_format(balance * item.sign)
    }

    app.page_out("ledger-list.html", model)
  end
end

 
MobileApp.new('actions' => {
  '*' => [SetupAF, LedgerList, nil],
}).run


