#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 支払いの削除


require 'payment-common.rb'

class PaymentsDestroy < Wafu::Action
  def execute af
    payment_amount = PaymentAmount.find(af['id'])
    payment = payment_amount.payment

    Payment.transaction {
      # 仕訳を削除
      JournalEntry.delete_all ['user_id = ? AND payment_amount_id = ?',
                               app.user.id, payment_amount.id]
      # 支払いを削除
      if payment.payment_amounts.size > 1
        payment_amount.destroy
      else
        payment.destroy # 親も削除
      end
    }

    app.set_flash 'notice', '支払いを削除しました。'
    app.redirect_to 'invoices-show.rb', :id => payment_amount.invoice.id
  end
end


PCView.new('actions' => {
             "*" => [Wafu::ActionForm, PaymentsDestroy, nil],
           }).run()
