# -*- mode:ruby; coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# PC用アプリケーションクラス

require 'accounting_app'
require LIBRARY_DIR + '/datesup'
require "banner.rb"


class PCView < AccountingApp
  def internal_error_message_out()
    cgi_header_out()
    print <<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
  <link rel="stylesheet" href="./default.css" type="text/css" charset="Shift_JIS">
  <title>内部エラー発生</title>
</head>
<body>
</table></ul></dl>
<h1>内部エラー発生</h1>
<p>予期しないエラーが発生しました。ご迷惑をお掛けします。
<p>プログラム修正の参考のため、エラーが発生したときの状況などをお送りいただけると助かります。よろしくお願いします。
#{comment_form()}
EOF
    print "<p>", CGI.escapeHTML($!.inspect), "\n"
    print "<p>"
    $@.each {|x| print CGI.escapeHTML(x), "<br>\n"}
    print "<hr>\n", CGI.escapeHTML(cgi.params.inspect)
    print <<EOF
<hr>
</body>
</html>
EOF
  end

  def login_form(mes)
    cgi_header_out(nil)

    print <<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
  <link rel="stylesheet" href="./default.css" type="text/css" charset="Shift_JIS">
  <link rel="stylesheet" href="#{theme_url(user)}" type="text/css">
  <script charset="Shift_JIS" type="text/javascript" src="./scripts.js"></script>
  <title>ログイン: #{SITE_NAME}</title>
</head>
<body>
#{body_header}
<h1>ログイン</h1>
EOF

    if mes == Wafu::LOGON_RETRY
      print "<p>ユーザIDまたはパスワードが違います。\n"
    elsif mes == Wafu::LOGON_EXPIRE
      print "<p>セッション維持時間を越えました。再ログインが必要です。\n"
    end
    print <<EOF
<form action="./login.rb" method="post">
<table class="frm">
  <tr><th nowrap align="right">ユーザID：<td><input type="text" name="user" size="10">
  <tr><th nowrap align="right">パスワード：<td><input type="password" name="pwd" size="10">
  <tr><td colspan="2" align="center">
    <input type="submit" name="login" value="ログイン">
</table>
</form>
<p>ケータイ版は、ログインしてから [ケータイにサイトのURLを送る] を行ってください。
<p><a href="sendpass.rb">[ユーザID・パスワードを忘れた場合]</a><br>
  <a href="signup.rb">[新規ユーザ登録]</a>

<p><a href="#{AppConfig[:site_top_url]}">[#{AppConfig[:site_name]} Home]</a>
EOF

    footer_out(nil)
  end

  def body_header
    r = <<EOF
<table border="0" align="center" width="100%">
  <tr>
    <td valign="top">
      <div class="main" style="position:static;float:none;margin:0;">
EOF
    return r
  end

  def get_navbar_modal()
    r = body_header << <<EOF
<div class="adminmenu">
  <span class="adminmenu"><a href="logoff.rb">[ログアウト]</a></span>
</div>
EOF
    return r
  end

  def get_navigation_bar()
    page_id = File.basename((ENV['SCRIPT_FILENAME'] || "accountbook"), ".rb").gsub(/\./, '')
    r = body_header << <<EOF
<script type="text/javascript">
var TIME_OUT = 250;
var selected_menu;
var timer_id;

function menu_open(id) 
{
  if (selected_menu) {
    menu_cancel_close();
    document.getElementById('menu' + selected_menu).style.visibility = "hidden";
  }
  selected_menu = id;
  document.getElementById("menu" + id).style.visibility = "visible";
}

function menu_set_timer() 
{
  timer_id = window.setTimeout( function() { 
      document.getElementById('menu' + selected_menu).style.visibility = "hidden"; 
      timer_id = null;
      selected_menu = null;      
    }, TIME_OUT);
}

function menu_cancel_close() 
{
  if (timer_id) {
    window.clearTimeout(timer_id);
    timer_id = null;
  }
}
</script>

<div class="adminmenu">
  <span class="adminmenu"><a href="logoff.rb">[ログアウト]</a></span>

  <ul id="menubar">
    <li>
      <span class="menu"><a href="./menu.rb">トップ</a></span>

    <li>
      <span class="menu" onmouseover="menu_open(1);" onmouseout="menu_set_timer();">出納</span>
      <ul id="menu1" class="submenu" onmouseover="menu_cancel_close();" onmouseout="menu_set_timer();">
        <li><a href="cash.rb">現金・預金出納帳</a>
        <li><a href="cash-balance.rb">残高を合わせる</a>
        <li><a href="credit.rb">債務の消し込み</a>
      </ul>

    <li>
      <span class="menu" onmouseover="menu_open(2);" onmouseout="menu_set_timer();">債務</span>
      <ul id="menu2" class="submenu" onmouseover="menu_cancel_close();" onmouseout="menu_set_timer();">
        <li><a href="invoices-list.rb">請求書の一覧</a>
        <li><a href="invoices-new.rb">新しい請求書 (債務)</a>
        <li><a href="credit.rb">債務の消し込み</a>
      </ul>

    <li>
      <span class="menu" onmouseover="menu_open(3);" onmouseout="menu_set_timer();">G/L</span>
      <ul id="menu3" class="submenu" onmouseover="menu_cancel_close();" onmouseout="menu_set_timer();">
        <li><a href="journal.rb">振替伝票</a>
        <li><a href="ledger.rb">元帳</a>
        <li><a href="journals-list.rb">仕訳帳</a>
      </ul>

    <li>
      <span class="menu" onmouseover="menu_open(4);" onmouseout="menu_set_timer();">実績</span>
      <ul id="menu4" class="submenu" onmouseover="menu_cancel_close();" onmouseout="menu_set_timer();">
        <li><a href="pl.rb">財務諸表</a>
        <li><a href="week.rb">週次推移表</a>
        <li><a href="month.rb">月次推移表</a>
      </ul>

    <li>
      <span class="menu" onmouseover="menu_open(5);" onmouseout="menu_set_timer();">予算</span>
      <ul id="menu5" class="submenu" onmouseover="menu_cancel_close();" onmouseout="menu_set_timer();">
        <li><a href="budgets-list.rb">予算の表示</a>
        <li><a href="actual.rb">予算実績対比</a>
      </ul>
  </ul><!-- menubar -->
    
</div>
EOF
    return r
  end

  # @deprecated
  def cgi_header_out(dummy__ = nil)
    print cgi.header({"type" => "text/html", "charset" => "UTF-8"})
  end

  # @deprecated
  # for backward compatibility
  def header_out(cgi, title)
    cgi_header_out(cgi)

    print <<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
  <link rel="stylesheet" href="./default.css" type="text/css" charset="Shift_JIS">
  <link rel="stylesheet" href="#{theme_url(user)}" type="text/css">
  <script charset="Shift_JIS" type="text/javascript" src="./scripts.js"></script>
  <title>#{title}: #{SITE_NAME}</title>
</head>
<body>
EOF
    print get_navigation_bar()
    print <<EOF
<h1>#{title}</h1>
EOF
  end

  def footer_out(dummy__ = nil)
    print get_footer()
    print <<EOF
</body>
</html>
EOF
  end

  def comment_form()
    key = CGI.escapeHTML(ENV['SCRIPT_FILENAME'] || "page-unknown")
    r = <<EOF
<form method="post" action="./feedback.rb">
  <input type="hidden" name="k" value="#{key}">
<table border="0" class="frm" style="margin:0 0 0 0">
EOF
    if !@user
      r += <<EOF
<tr><th align="right" nowrap>お名前：<td align="left"><input type="text" name="u" size="30">
<tr><th align="right">メールアドレス：<td align="left"><input type="text" name="m" size="30">
EOF
    end
    r += <<EOF
  <tr><th align="right" valign="top" nowrap>コメント：
    <td><textarea name="body" rows="6" cols="50"></textarea>
  <tr><td colspan="2" align="center">
    <input type="submit" value="送信">
</table>
</form>
EOF
    return r
  end

  def banner_text()
    page_id = File.basename((ENV['SCRIPT_FILENAME'] || "accountbook"), ".rb").gsub(/\./, '')
    return <<EOF
<br>
<!-- VC active -->
<SCRIPT type="text/javascript" LANGUAGE="JavaScript">
<!--
// ValueParameters
ValueHost = "hs0014065";
ValueLoaded = false;
ValueID = "pagebuster";
ValueVersion = "1.1";
ValueBannerType = "std";

ValueWidth = 468;
ValueHeight = 60;
//-->
</SCRIPT>
<SCRIPT type="text/javascript" LANGUAGE="Javascript" SRC="http://oz.valueclick.ne.jp/jsmaster"></SCRIPT>
<SCRIPT type="text/javascript" LANGUAGE="JavaScript">
<!--
if (ValueLoaded) ValueShowAd();
//-->
</SCRIPT>
<NOSCRIPT>
<A HREF="http://oz.valueclick.ne.jp/redirect?host=hs0014065&amp;size=468x60&amp;t=std&amp;b=#{page_id}&amp;noscript=1&amp;v=0" TARGET="_top">
<IMG BORDER="0" WIDTH="468" HEIGHT="60" ALT="Click here to visit our sponsor" SRC="http://oz.valueclick.ne.jp/cycle?host=hs0014065&amp;size=468x60&amp;t=std&amp;b=#{page_id}&amp;noscript=1">
  </A>
</NOSCRIPT>
<!-- vc active -->







<!-- VC active -->
<SCRIPT type="text/javascript" LANGUAGE="JavaScript">
<!--
// ValueParameters
ValueHost = "hs0014065";
ValueLoaded = false;
ValueID = "pagebuster";
ValueVersion = "1.1";
ValueBannerType = "std";

ValueWidth = 125;
ValueHeight = 125;
//-->
</SCRIPT>
<SCRIPT type="text/javascript" LANGUAGE="Javascript" SRC="http://oz.valueclick.ne.jp/jsmaster"></SCRIPT>
<SCRIPT type="text/javascript" LANGUAGE="JavaScript">
<!--
if (ValueLoaded) ValueShowAd();
//-->
</SCRIPT>

<NOSCRIPT>
<A HREF="http://oz.valueclick.ne.jp/redirect?host=hs0014065&amp;size=125x125&amp;t=std&amp;b=#{page_id}&amp;noscript=1&amp;v=0" TARGET="_top">
<IMG BORDER="0" WIDTH="125" HEIGHT="125" ALT="Click here to visit our sponsor" SRC="http://oz.valueclick.ne.jp/cycle?host=hs0014065&amp;size=125x125&amp;t=std&amp;b=#{page_id}&amp;noscript=1">
  </A>
</NOSCRIPT>
<!-- vc active -->
EOF
  end

  def get_footer()
    s = <<EOF
  </div> <!-- main -->
</td>
<td valign="top">
  <div class="sidebar" style="position:static;float:none;width:168px;">
    <script type="text/javascript"><!--
google_ad_client = "pub-1525727753584386";
/* 160x600, 作成済み 09/02/25 */
google_ad_slot = "9864589493";
google_ad_width = 160;
google_ad_height = 600;
//-->
    </script>
    <script type="text/javascript"
src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
    </script>

  </div> <!-- sidebar -->
</table>

<hr noshade />

<div class="footer">
Powered by <a href="http://www.nslabs.jp/ac/">Q's Web Account Book</a>.<br>
Copyright (c) 2002-2007,2010 HORIKAWA Hisashi. All rights reserved.
</div>
EOF
    #'
    return s + banner_text()
  end

  def theme_url(user)
    prof = user ? user.user_setting : nil
    if prof && prof.theme_name && prof.theme_name != ''
      return AppConfig[:theme_base_url] + "/" + prof.theme_name + "/" + prof.theme_name + ".css"
    else
      return AppConfig[:theme_base_url] + "/" + AppConfig[:theme_default] + "/" + AppConfig[:theme_default] + ".css"
    end
  end

  # レスポンスを生成する
  # @param filename テンプレートのファイル名
  # @param model Amritaモデル
  def page_out(filename, model)
    raise SecurityError if filename =~ /\.\./
                                      
    tmpl = Amrita::TemplateText.new(File.read("#{APP_ROOT}/templates/" + filename).untaint)
    tmpl.amrita_id = "tid"
    mapping = model.dup.update({
      :theme => theme_url(user),
      :navbar => Amrita::SanitizedString[get_navigation_bar()],
      :navbar_modal => Amrita::SanitizedString[get_navbar_modal()],
      :footer => Amrita::SanitizedString[get_footer()],
      :sitename => CGI.escapeHTML(SITE_NAME),
    })
    cgi_header_out()
    utext = ""
    tmpl.expand(utext, mapping)
    print utext
  end
end


class DateRangeActionForm < Wafu::ActionForm
  attr_reader :begin_date, :end_date
  attr_reader :by, :bm, :bd, :ey, :em, :ed

  def setup()
    from = app.cgi.get("from", nil)
    to = app.cgi.get("to", nil)
    if from && to
      from = Date.parse(from)
      to = Date.parse(to)
      @by, @bm, @bd = [from.year, from.mon, from.day]
      @ey, @em, @ed = [to.year, to.mon, to.day]
    else
      @by = @app.cgi["byear"].first
      @bm = @app.cgi["bmon"].first
      @bd = @app.cgi["bday"].first
      @ey = @app.cgi["eyear"].first
      @em = @app.cgi["emon"].first
      @ed = @app.cgi["eday"].first
    end
  end

  def validate()
    error = []
    jdb = Date.exist?(@by.to_i, @bm.to_i, @bd.to_i)
    jde = Date.exist?(@ey.to_i, @em.to_i, @ed.to_i)
    error << "開始日が正しくありません。" if (!jdb)
    error << "終了日が正しくありません。" if (!jde)
    if jdb && jde
      error << "終了日が開始日より古い日付になっています。" if (jde < jdb)
      @begin_date = Date.new1(jdb)
      @end_date = Date.new1(jde)
    end

    return set_error(error)
  end
end


# 日付選択コントロール
def get_sel_date(name_prefix, y, m, d)
  r = ""
  if y
    r << %Q(<input type="text" class="num" size="5" name="#{name_prefix}year" value="#{y}">年)
  end
  if m
    r << %Q(<input type="text" class="num" size="3" name="#{name_prefix}mon" value="#{m}">月)
  end
  if d
    r << %Q(<input type="text" class="num" size="3" name="#{name_prefix}day" value="#{d}">日)
  end
  r << %q!<input type="button" onClick="openCalendar(!   # "
  r << (y ? "this.form['#{name_prefix}year']," : "null,") <<
      (m ? "this.form['#{name_prefix}mon']," : "null,") <<
      (d ? "this.form['#{name_prefix}day']" : "null") << 
      %q!,event,'mm/dd');" value="...">!    # "
  return Amrita::SanitizedString[r]
end

# カレンダ付き日付選択
# ActiveRecordを前提としたフォームコントロール名
#   @param object_name インスタンス変数名. なくてもエラーにはしない
def date_select2 object_name, method_name
  raise TypeError if !object_name.is_a?(String)
  raise TypeError if !method_name.is_a?(String)

  obj = instance_variable_get("@#{object_name}")
  v = obj.respond_to?(method_name) ? obj.send(method_name) : Date.today

  cname = object_name + "[" + method_name
  r = <<EOF
<input type="text" class="num" size="5" name="#{cname}(1i)]" value="#{v.year}" />年
<input type="text" class="num" size="3" name="#{cname}(2i)]" value="#{v.month}" />月
<input type="text" class="num" size="3" name="#{cname}(3i)]" value="#{v.day}" />日
<input type="button" onClick="openCalendar(this.form['#{cname}(1i)]'],this.form['#{cname}(2i)]'],this.form['#{cname}(3i)]'],event,'yy/mm/dd');" value="..." style="padding:0">
EOF
  return r
end

def date_from_select h, name
  return Date.new(h["#{name}(1i)"].to_i, h["#{name}(2i)"].to_i, 
                  h["#{name}(3i)"].to_i)
end


# 元帳/仕訳帳から編集画面へのリンク
def get_edit_url(r, fixed_day, prev_url)
  if r.invoice
    edit = nil
  elsif r.payment_amount
    edit = r.date > fixed_day ? {
      :edit => "payment-edit.rb?id=#{r.payment_amount.id}"} : nil
  else
    edit = r.date > fixed_day ? {
      :edit => "journals-edit.rb?action=edit&amp;seq=#{r.id}&amp;prev=#{CGI.escape(prev_url)}"} : nil
  end
  return edit
end

# 前の行と同じなら月日のみ
def format_date2(cur_day, last_day)
  if !last_day || last_day.year != cur_day.year
    sprintf("%04d年<br>\n%02d.%02d", cur_day.year, cur_day.mon, cur_day.day)
  else
    sprintf("%02d.%02d", cur_day.mon, cur_day.day)
  end
end
