#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

require "pcview.rb"


class MailCheckAF < Wafu::ActionForm
  attr_reader :email
  def validate
    err = []
    @email = app.cgi.get("m")
    if !valid_mail_addr(@email)
      err << "メールアドレスが正しくありません。"
    end
    return set_error(err)
  end
end


class DoneForm < Wafu::Action
  def execute(af)
    send_mail(*format_mail(app.user, af.email))
    model = {
      :mobileaddr => af.email
    }
    app.page_out("sendmobile2.html", model)
  end

  def format_mail(ent, mobileaddr)
    url = "#{SITE_URL}m.rb?login=t&u=#{CGI.escape(ent.login)}&d=#{ent.crypted_password}"

    header = {"From" => FROM_ADDR,
              "To" => mobileaddr,
              "MIME-Version" => "1.0",
              "Content-Type" => "text/plain; charset=ISO-2022-JP",
              "Subject" => "#{SITE_NAME}: ケータイ用URL",
              "Reply-To" => ADMIN_ADDR }

    mailbody = <<EOF
#{ent.name} さんのケータイ用URLは、
#{url}
です。
----------------------------
#{SITE_NAME} お問合せ先 mailto:#{ADMIN_ADDR}
EOF
    return [header, mailbody]
  end
end


class RedoForm < Wafu::Action
  def execute(af)
    model = {
      :m => af.email,
      :from_addr => FROM_ADDR,
    }
    model[:error] = {:message => af.errors} if af.error?

    app.page_out("sendmobile.html", model)
  end
end


PCView.new('actions' => {
  '*' => [MailCheckAF, DoneForm, RedoForm]
}).run
