#!/home/netsphere/bin/ruby
# -*- mode:ruby; coding:utf-8 -*-

# Q's Web Account Book
# Copyright (c) 2002-2007,2010 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/

# メールアドレスの変更（変更確認の送信）

require "pcview.rb"
require APP_ROOT + '/models/email_log'


class FirstCheck < Wafu::ActionForm
  def setup
    @email = @app.user.email
  end

=begin
  def validate
    err = []
    if @app.user.login == "guest"
      err << "ゲストユーザは変更できません。"
    end
    return set_error(err)
  end
=end

  attr_reader :email
end


class ProfileSetting < Wafu::Action
  def execute af
    if app.user.login == "guest"
      @errors = ["ゲストユーザはメールアドレスを変更できません。"]
      @page_title = "メールアドレス変更"
      render "account-forbid-guest", :layout => "application"
      return
    end

    model = {
      :email => af.email,
      :from_addr => AppConfig[:prog_mail],
    }
    if af.error?
      model[:error] = {:list => af.errors}
    end
    @app.page_out("setting-mail.html", model)
  end
end


class UpdateAF < Wafu::ActionForm
  attr_reader :email

  def setup()
    @email = @app.cgi.get('email')
  end

  def validate()
    err = []
    if @app.user.login == "guest"
      err << "ゲストユーザは変更できません。"
    end
    if !@email || @email == "" || !valid_mail_addr(@email)
      err << "メールアドレスが正しくありません。"
    end

    return set_error(err)
  end
end

class ProfileSettingDone < Wafu::Action
  def execute(af)
    # digestが推測できたらダメ。
    digest_key = Time.now.to_f.to_s + rand().to_s

    el = EmailLog.new(:user => @app.user,
                      :sent_at => Time.now,
                      :email => af.email,
                      :digest => Digest::SHA256.hexdigest(digest_key))
    send_mail(*format_mail(el.digest, af.email))
    el.save!
    
    # 表示
    app.page_out("setting-mail2.html", {})
  end

  def format_mail(token, newmail)
    header = {
      "From" => AppConfig[:prog_mail],
      "To" => newmail,
      "MIME-Version" => "1.0",
      "Content-Type" => "text/plain; charset=ISO-2022-JP",
      "Reply-To" => AppConfig[:confirm_mail],
      "Subject" => "#{SITE_NAME}: ◆ メールアドレスの確認 ◆",
    }

    mailbody = <<EOF
confirm #{token}

◆ メールアドレスの確認 ◆

#{SITE_NAME} のメールアドレス変更の確認メールです。
confirmから始まる行を削除せずに、そのまま返信してください。

この件に関して思い当たる節がないときは、そのまま無視してください。
---------------------------------------------------------
お問い合わせ先 mailto:#{ADMIN_ADDR}
EOF
    return [header, mailbody]
  end
end


PCView.new('actions' => {
  "*" => [FirstCheck, ProfileSetting, ProfileSetting],
  "update" => [UpdateAF, ProfileSettingDone, ProfileSetting]
}).run()

