#!/home/netsphere/bin/ruby
# -*- mode:ruby; coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# プロフィールの変更

require "pcview.rb"

class FirstCheck < Wafu::ActionForm
  def setup
    @realname = @app.user.name
    @closing_day = @app.user.user_setting.closing_day
    @newpwd = @newpwd2 = ""
  end
  attr_reader :realname, :closing_day, :newpwd, :newpwd2
end

class ProfileSetting < Wafu::Action
  def execute(af)
    model = {
      :realname => af.realname,
      :sel_day => menu_control("day", (1..31), af.closing_day)
    }
    if af.error?
      model[:error] = {:list => af.errors}
    end
    @app.page_out("setting-profile1.html", model)
  end
end


class UpdateAF < Wafu::ActionForm
  attr_reader :realname, :closing_day, :newpwd, :newpwd2

  def setup()
    @realname = @app.cgi.get("realname")
    @closing_day = @app.cgi.get("day").to_i
    @newpwd = @app.cgi.get('newpwd')
    @newpwd2 = @app.cgi.get('newpwd2')
  end

  def validate()
    err = []
    if @app.user.login == "guest"
      if (@newpwd && @newpwd != "") || (@newpwd2 && @newpwd2 != "")
        err << "ゲストユーザは、パスワードを変更できません。"
      end
    end

    if !@realname || @realname == ""
      err << "お名前がありません。"
    end
    if @closing_day < 1 || @closing_day > 31
      err << "internal error: 月末日が正しくありません。"
    end
    if @newpwd && @newpwd != ""
      err << "パスワードが同じではありません。" if @newpwd != @newpwd2
    end

    return set_error(err)
  end
end

class ProfileSettingDone < Wafu::Action
  def execute(af)
    User.transaction {
      @app.user.name = af.realname
      if af.newpwd && af.newpwd != ""
        @app.user.set_password(af.newpwd)
      end
      @app.user.save!
      us = @app.user.user_setting
      us.closing_day = af.closing_day
      us.save!
    }

    app.set_flash("notice", "プロフィールを更新しました。")
    app.redirect_to 'menu.rb'
  end
end


PCView.new('actions' => {
      "*" => [FirstCheck, ProfileSetting, nil],
      "update" => [UpdateAF, ProfileSettingDone, ProfileSetting]
    }).run
