# -*- coding:utf-8 -*-

# Q's Web Account Book
# Copyright (c) 2002-2007,2010 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/

# 勘定科目controller

require 'pcview.rb'
require APP_ROOT + '/models/account_title'
require APP_ROOT + '/models/journal_entry'


# 編集画面の表示
class EditForm < Wafu::Action
  def get_sel_actype(name, default)
    return menu_control(name, 1..7, default) {|k| AccountTitle::ACTYPE_NAMES[k] }
  end

  def get_sel_cftype(name, default)
    return menu_control(name, 1..4, default) {|k| AccountTitle::CFTYPE_NAMES[k]}
  end

  # @deprecated   次を利用すること; AccountTitle#can_delete?
  def has_journal?(item_id)
    j = JournalEntry.find(:first,
               :conditions => ['user_id = ? and (dr_code = ? or cr_code = ?)',
                               @app.user.id, item_id, item_id])
    return j ? true : false
  end

  def execute(af)
    model = {
      :name => af.name,
      :mobname => af.name_short,
      :sort => af.sort,
      :ac_type => get_sel_actype("actype", af.ac_type),
      :cf_type => get_sel_cftype("cftype", af.cf_type),
      :desc => af.desc,
      :active => (af.active != 0 ? "checked" : nil),
    }

    if af.item
      # 編集
      model.update(:id => af.item.id,
                   :title => '勘定科目の編集',
                   :action => 'titles-edit.rb',
                   :submit => '更新')
      if !has_journal?(af.item.id)
        model[:delete] = true
      end
    else
      # 新規作成
      model.update(:title => '新しい勘定科目',
                   :action => 'titles-new.rb',
                   :submit => '作成')
    end

    @app.page_out('titles-edit.html', model)
  end
end


class UpdateAF < Wafu::ActionForm
  def validate
    err = []

    n = {
      'name' => 'name', 'mobname' => 'name_short', 'sort' => 'sort',
      'actype' => 'ac_type', 'cftype' => 'cf_type', 'desc' => 'desc',
      'active' => 'active'}
    n.each {|cginame, vname|
      instance_variable_set('@' + vname, @app.cgi.get(cginame, nil))
    }

    if @app.cgi.get('id', '') != ''
      @item = AccountTitle.find_item(@app.cgi.get('id', nil), @app.user) 
      if !@item
        err << 'internal error: idが指定されていない'
        return set_error(err)
      end
    end
  end
  attr_reader :name, :name_short, :sort, :ac_type, :cf_type, :desc, :active
  attr_reader :item
end
