#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Web Account Book
# Copyright (c) 2002-2007,2010 HORIKAWA Hisashi. All rights reserved.
#   http://www.nslabs.jp/

# 勘定科目の編集

require './titles-common.rb'


class FirstCheck < Wafu::ActionForm
  def validate
    item_id = @app.cgi.get('ac', nil)
    if !item_id
      err = ["internal error: idが指定されていない"]
      return set_error(err)
    end

    @item = AccountTitle.find_item(item_id, @app.user)
    raise if !@item
    @name = @item.name
    @name_short = @item.name_short
    @sort = @item.sort
    @ac_type = @item.ac_type
    @cf_type = @item.cf_type
    @desc = @item.description
    @active = @item.active
  end
  attr_reader :name, :name_short, :sort, :ac_type, :cf_type, :desc, :active
  attr_reader :item
end


class TitleUpdate < Wafu::Action
  def execute(af)
    af.item.update_attributes(:name => af.name,
                              :name_short => af.name_short,
                              :sort => af.sort,
                              :ac_type => af.ac_type,
                              :cf_type => af.cf_type,
                              :description => af.desc,
                              :active => (af.active && af.active != "" ? 1 : 0)
                              )
    af.item.save!

    @app.set_flash "notice", "科目「#{af.name}」を更新しました。"
    @app.set_redirect "titles.rb"
  end
end


PCView.new('actions' => {
  "*" => [FirstCheck, EditForm, nil],
  "update" => [UpdateAF, TitleUpdate, EditForm],
}).run()
