#!/home/netsphere/bin/ruby
# -*- coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/

# 新しい勘定科目


require './titles-common.rb'


class FirstCheck < Wafu::ActionForm
  def setup
    @desc = ''
  end
  attr_reader :name, :name_short, :sort, :ac_type, :cf_type, :desc, :active
  attr_reader :item
end


# 勘定科目を生成
class TitleCreate < Wafu::Action
  def execute(af)
    item = AccountTitle.new(:user => @app.user,
                            :name => af.name,
                            :name_short => af.name_short,
                            :sort => af.sort.to_i,
                            :ac_type => af.ac_type,
                            :cf_type => af.cf_type,
                            :description => af.desc,
                            :active => (af.active && af.active != "" ? 1 : 0)
                            )
    item.save!

    @app.set_flash "notice", "科目「#{af.name}」を作成しました。"
    @app.set_redirect "titles.rb"
  end
end


PCView.new('actions' => {
  '*' => [FirstCheck, EditForm, nil],
  'update' => [UpdateAF, TitleCreate, EditForm],
}).run()
