#!/home/netsphere/bin/ruby
# -*- mode:ruby; coding:utf-8 -*-

# Q's Account Book
# Copyright (c) 2002-2007 HORIKAWA Hisashi. All rights reserved.
#   mailto:vzw00011@nifty.ne.jp
#   http://www.nslabs.jp/


# 確認メールを受信して、ユーザのメールアドレスを変更する。

class File
  def File.rel2abs(rel_path, this_file)
    File.expand_path(rel_path, File.dirname(File.expand_path(this_file)))
  end
end

require File.rel2abs('./path-conf.rb', __FILE__)
require 'rubygems'
gem 'activerecord'
require 'active_record'
require 'mailread'
require APP_ROOT + '/models/email_log'
require APP_ROOT + '/models/user'


# 期限の過ぎているものを削除する
def sweep_logs
  t = Time.now - (60 * 60 * 24) * 3
  EmailLog.delete_all ['digest is not null AND sent_at < ?', t]
end

def check_and_update(m, digest)
  e = EmailLog.find_by_digest(digest)
  if e && m['From'].index(e.email)
    EmailLog.transaction {
      e.user.email = e.email
      e.digest = nil
      e.user.save!
      e.save!
    }
  end
end

def main
  ActiveRecord::Base.establish_connection AR_OPTION

  m = Mail.new($stdin)
  m.body.each {|line|
    a = line.scan /confirm ([0-9a-f]{64})/
    if a && !a.empty?
      check_and_update(m, a[0][0])
      break
    end
  }
  sweep_logs
end

main
